/*
 * Copyright (C) 2008 Luke Kenneth Casson Leighton <lkcl@lkcl.net>
 * Copyright (C) 2008 Alp Toker <alp@atoker.com>
 * Copyright (C) 2008 Apple Inc.
 */
#ifndef __GdomXPathExpression_H__
#define __GdomXPathExpression_H__
#include <webkit/webkitdefines.h>
#include "gdom/GdomDOMObject.h"
#include "gdom/GdomNode.h"
#include "gdom/GdomXPathResult.h"
#include "glib-object.h"


G_BEGIN_DECLS

typedef struct _GdomXPathExpression GdomXPathExpression;
typedef struct _GdomXPathExpressionClass GdomXPathExpressionClass;


#define GDOM_TYPE_X_PATH_EXPRESSION            (gdom_x_path_expression_get_type())
#define GDOM_X_PATH_EXPRESSION(obj)            (G_TYPE_CHECK_INSTANCE_CAST((obj), GDOM_TYPE_X_PATH_EXPRESSION, GdomXPathExpression))
#define GDOM_X_PATH_EXPRESSION_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST((klass),  GDOM_TYPE_X_PATH_EXPRESSION, GdomXPathExpression)Class)
#define GDOM_IS_X_PATH_EXPRESSION(obj)         (G_TYPE_CHECK_INSTANCE_TYPE((obj), GDOM_TYPE_X_PATH_EXPRESSION))
#define GDOM_IS_X_PATH_EXPRESSION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass),  GDOM_TYPE_X_PATH_EXPRESSION))
#define GDOM_X_PATH_EXPRESSION_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS((obj),  GDOM_TYPE_X_PATH_EXPRESSION, GdomXPathExpressionClass))

typedef struct _GdomXPathExpressionPrivate GdomXPathExpressionPrivate;

struct _GdomXPathExpression {
    GdomDOMObject parent_instance;
    GdomXPathExpressionPrivate *priv;
};

struct _GdomXPathExpressionClass {
    GObjectClass parent_class;
};

WEBKIT_API GType
gdom_x_path_expression_get_type (void);

WEBKIT_API GdomXPathResult *
gdom_x_path_expression_evaluate (GdomXPathExpression *thiz, GdomNode * context_node, gushort type, GdomXPathResult * in_result);

G_END_DECLS

#endif /* __GdomXPathExpression_H__ */
